<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: C:/Data/Git/MeLOn/common/inc/matern.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('matern_8h_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">matern.h</div></div>
</div><!--header-->
<div class="contents">
<a href="matern_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**********************************************************************************</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment">* Copyright (c) 2020 Process Systems Engineering (AVT.SVT), RWTH Aachen University</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment">*</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment">* This program and the accompanying materials are made available under the</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment">* terms of the Eclipse Public License 2.0 which is available at</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment">* http://www.eclipse.org/legal/epl-2.0.</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment">*</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment">* SPDX-License-Identifier: EPL-2.0</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment">*</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment">* @file gp_data.h</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment">* @brief File containing declaration of matern kernel classes</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="comment">*</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment">**********************************************************************************/</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &quot;<a class="code" href="kernel_8h.html">kernel.h</a>&quot;</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="matern_8h.html#aee89c193f8f9fd486ebeecd9604daa6f">   20</a></span><span class="preprocessor">#define USE_TAYLORMADE_RELAXATIONS</span></div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="comment">//#undef USE_TAYLORMADE_RELAXATIONS</span></div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#ifdef USE_TAYLORMADE_RELAXATIONS</span></div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="preprocessor">#include &quot;ffunc.hpp&quot;</span></div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span> </div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacemelon.html">melon</a> {</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>    <span class="keyword">namespace </span>kernel {</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span><span class="preprocessor">#ifdef USE_TAYLORMADE_RELAXATIONS</span></div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span> </div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>        <span class="keyword">using </span>mc::covariance_function;</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span> </div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">inline</span> T</div>
<div class="foldopen" id="foldopen00037" data-start="{" data-end="}">
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno"><a class="line" href="namespacemelon_1_1kernel.html#af325146267524e3bec94d0535ffcebcb">   37</a></span>            <a class="code hl_function" href="namespacemelon_1_1kernel.html#af325146267524e3bec94d0535ffcebcb">covar_matern_1</a>(<span class="keyword">const</span> T&amp; x) {</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>            <span class="keywordflow">return</span> covariance_function(x, 1);</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>        }</div>
</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span> </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">inline</span> T</div>
<div class="foldopen" id="foldopen00042" data-start="{" data-end="}">
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno"><a class="line" href="namespacemelon_1_1kernel.html#af6326be288cac254a67493632f4ddf76">   42</a></span>            <a class="code hl_function" href="namespacemelon_1_1kernel.html#af6326be288cac254a67493632f4ddf76">covar_matern_3</a></div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>            (<span class="keyword">const</span> T&amp; x) {</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>            <span class="keywordflow">return</span> covariance_function(x, 2);</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>        }</div>
</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span> </div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">inline</span> T</div>
<div class="foldopen" id="foldopen00048" data-start="{" data-end="}">
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno"><a class="line" href="namespacemelon_1_1kernel.html#a1805b33bc8adf981fa654aaf8ff1fae7">   48</a></span>            <a class="code hl_function" href="namespacemelon_1_1kernel.html#a1805b33bc8adf981fa654aaf8ff1fae7">covar_matern_5</a></div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>            (<span class="keyword">const</span> T&amp; x) {</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>            <span class="keywordflow">return</span> covariance_function(x, 3);</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>        }</div>
</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span> </div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">inline</span> T</div>
<div class="foldopen" id="foldopen00054" data-start="{" data-end="}">
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno"><a class="line" href="namespacemelon_1_1kernel.html#a2a227d1955df0c4b01af2c41b9470e95">   54</a></span>            <a class="code hl_function" href="namespacemelon_1_1kernel.html#a2a227d1955df0c4b01af2c41b9470e95">covar_sqrexp</a></div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>            (<span class="keyword">const</span> T&amp; x) {</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>            <span class="keywordflow">return</span> covariance_function(x, 4);</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>        }</div>
</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span> </div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span><span class="preprocessor">#endif</span></div>
<div class="foldopen" id="foldopen00064" data-start="{" data-end="};">
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno"><a class="line" href="structmelon_1_1kernel_1_1_kernel_data.html">   64</a></span>        <span class="keyword">struct </span><a class="code hl_struct" href="structmelon_1_1kernel_1_1_kernel_data.html">KernelData</a> {</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno"><a class="line" href="structmelon_1_1kernel_1_1_kernel_data.html#a17fc12e78f39a1e93d89f241083ebab1">   65</a></span>            <span class="keywordtype">double</span> <a class="code hl_variable" href="structmelon_1_1kernel_1_1_kernel_data.html#a17fc12e78f39a1e93d89f241083ebab1">sf2</a>;</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno"><a class="line" href="structmelon_1_1kernel_1_1_kernel_data.html#ad3f01d89c0bfdd53dda0b31f84319dcf">   66</a></span>            std::vector&lt;double&gt; <a class="code hl_variable" href="structmelon_1_1kernel_1_1_kernel_data.html#ad3f01d89c0bfdd53dda0b31f84319dcf">ell</a>;</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>        };</div>
</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span> </div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00074" data-start="{" data-end="};">
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern.html">   74</a></span>        <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_stationary_kernel.html">StationaryKernel</a>&lt;T, V&gt; {</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>        <span class="keyword">public</span>:</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>            <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern.html#a949e9259d57135cf1dbb1b8c8fa2bd2f">Matern</a>();</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>            <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern.html#a949e9259d57135cf1dbb1b8c8fa2bd2f">Matern</a>(std::shared_ptr&lt;const KernelData&gt; data);</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span> </div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>        <span class="keyword">protected</span>:</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>            <span class="keyword">using </span>typename <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Kernel&lt;T, V&gt;::RET</a>;</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span> </div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern.html#afd32a89a7eeff017e7c811c4c4a3a64e">   82</a></span>            std::shared_ptr&lt;const KernelData&gt; <a class="code hl_variable" href="classmelon_1_1kernel_1_1_matern.html#afd32a89a7eeff017e7c811c4c4a3a64e">_data</a>;    </div>
<div class="foldopen" id="foldopen00091" data-start="{" data-end="}">
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern.html#a23dc40f992932497afc16a00f20f2e77">   91</a></span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern.html#a23dc40f992932497afc16a00f20f2e77">_quadratic_distance</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2)<span class="keyword"> override </span>{</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>                <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distance = 0;</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span> </div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>                <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; x1.size(); i++) {        <span class="comment">// i the demension of X and X_test</span></div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>                    distance += pow(x1.at(i) - x2.at(i), 2) / pow(<a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern&lt;T, V&gt;::_data</a>-&gt;ell.at(i), 2);</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>                }</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span> </div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>                <span class="keywordflow">return</span> distance;</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>            };</div>
</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span> </div>
<div class="foldopen" id="foldopen00106" data-start="{" data-end="}">
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern.html#a85fac54714c648155ccb76ca58b140dc">  106</a></span>            <span class="keyword">auto</span> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern.html#a85fac54714c648155ccb76ca58b140dc">_euclidian_distance</a>(<a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> quadraticDistance) {</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span> </div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>                <span class="keywordtype">double</span> <span class="keyword">const</span> epsilon = 1e-16;</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>                <span class="comment">// Small number to avoid gradient calculation of sqrt(x) function at x = 0. </span></div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>                <span class="comment">// Otherwise this leads to longer computation time of IPOPT iterations in the preprocessing. (SLSQP works very quick with epsilon = 0).</span></div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>                <span class="comment">// In an example, epsilon =  1e-16 leads to an error of the prediction in the order of 1e-8. </span></div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>                <span class="comment">// We accept this error.</span></div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span> </div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>                <span class="keyword">auto</span> distance = quadraticDistance + epsilon;</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>                distance = sqrt(distance);</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span> </div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>                <span class="keywordflow">return</span> distance;</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>            };</div>
</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>        };</div>
</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span> </div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00126" data-start="{" data-end="};">
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern12.html">  126</a></span>        <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_matern12.html">Matern12</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern</a>&lt;T, V&gt; {</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>        <span class="keyword">public</span>:</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>            <span class="keyword">using </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern</a>&lt;T, V&gt;<a class="code hl_function" href="classmelon_1_1kernel_1_1_matern.html#a949e9259d57135cf1dbb1b8c8fa2bd2f">::Matern</a>;</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>            <span class="keyword">using </span>typename <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Kernel&lt;T, V&gt;::RET</a>;</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span> </div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern12.html#abee77e01af24c67dfc897e85cc9fe9e0">evaluate_kernel</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2);</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern12.html#abee77e01af24c67dfc897e85cc9fe9e0">evaluate_kernel</a>(<a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distance);</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern12.html#afe39812dc7ba20fbd9dccd36ef0b84cb">calculate_distance</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2);</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>        };</div>
</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span> </div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00141" data-start="{" data-end="};">
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern32.html">  141</a></span>        <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_matern32.html">Matern32</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern</a>&lt;T, V&gt; {</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>        <span class="keyword">public</span>:</div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>            <span class="keyword">using </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern</a>&lt;T, V&gt;<a class="code hl_function" href="classmelon_1_1kernel_1_1_matern.html#a949e9259d57135cf1dbb1b8c8fa2bd2f">::Matern</a>;</div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>            <span class="keyword">using </span>typename <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Kernel&lt;T, V&gt;::RET</a>;</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span> </div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern32.html#aaec97a47e2fbdafeb544a133a1096ff5">evaluate_kernel</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2);</div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern32.html#aaec97a47e2fbdafeb544a133a1096ff5">evaluate_kernel</a>(<a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distance);</div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern32.html#aa162953dea6b15059836429dbd05607d">calculate_distance</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2);</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>        };</div>
</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span> </div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00156" data-start="{" data-end="};">
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern52.html">  156</a></span>        <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_matern52.html">Matern52</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern</a>&lt;T, V&gt; {</div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>        <span class="keyword">public</span>:</div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>            <span class="keyword">using </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern</a>&lt;T, V&gt;<a class="code hl_function" href="classmelon_1_1kernel_1_1_matern.html#a949e9259d57135cf1dbb1b8c8fa2bd2f">::Matern</a>;</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>            <span class="keyword">using </span>typename <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Kernel&lt;T, V&gt;::RET</a>;</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span> </div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern52.html#afa52e2e7fcf02852db995e5570303609">evaluate_kernel</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2);</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern52.html#afa52e2e7fcf02852db995e5570303609">evaluate_kernel</a>(<a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distance);</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern52.html#a0858a9caccf0a87cd283504d80cc5fea">calculate_distance</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2);</div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>        };</div>
</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span> </div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00171" data-start="{" data-end="};">
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern_inf.html">  171</a></span>        <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_matern_inf.html">MaternInf</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern</a>&lt;T, V&gt; {</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>        <span class="keyword">public</span>:</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>            <span class="keyword">using </span><a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern</a>&lt;T, V&gt;<a class="code hl_function" href="classmelon_1_1kernel_1_1_matern.html#a949e9259d57135cf1dbb1b8c8fa2bd2f">::Matern</a>;</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>            <span class="keyword">using </span>typename <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Kernel&lt;T, V&gt;::RET</a>;</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span> </div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern_inf.html#a234fac115337961d3b38bf311003f39e">evaluate_kernel</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2);</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern_inf.html#a234fac115337961d3b38bf311003f39e">evaluate_kernel</a>(<a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distance);</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern_inf.html#a4ac55cf3cc87491b112617c987bf69b9">calculate_distance</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2);</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>        };</div>
</div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span> </div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern.html#a949e9259d57135cf1dbb1b8c8fa2bd2f">  186</a></span>        <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern.html#a949e9259d57135cf1dbb1b8c8fa2bd2f">Matern&lt;T, V&gt;::Matern</a>() {}</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span> </div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00189" data-start="{" data-end="}">
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern.html#a124b4208b37454e64970269ab06c40b9">  189</a></span>        <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern.html#a949e9259d57135cf1dbb1b8c8fa2bd2f">Matern&lt;T, V&gt;::Matern</a>(std::shared_ptr&lt;const KernelData&gt; data) : <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern</a>() {</div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span>            <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern&lt;T, V&gt;::_data</a> = data;</div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>        }</div>
</div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span> </div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span> </div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span>        <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>        <span class="comment">// Matern1/2</span></div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>        <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span> </div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00199" data-start="{" data-end="}">
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern12.html#acce6e46b9760039fafc1a6ca06bf0366">  199</a></span>        <span class="keyword">typename</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Matern12&lt;T,V&gt;::RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern12.html#abee77e01af24c67dfc897e85cc9fe9e0">Matern12&lt;T, V&gt;::evaluate_kernel</a>(<a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distance) {</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span> </div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span><span class="preprocessor">#ifdef USE_TAYLORMADE_RELAXATIONS</span></div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>            <span class="keywordflow">return</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern&lt;T, V&gt;::_data</a>-&gt;sf2 * <a class="code hl_function" href="namespacemelon_1_1kernel.html#af325146267524e3bec94d0535ffcebcb">covar_matern_1</a>(distance);</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> euclidianDistance = sqrt(distance + 1e-16);</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>            <span class="keywordflow">return</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern&lt;T, V&gt;::_data</a>-&gt;sf2 *  exp(-euclidianDistance);</div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>        }</div>
</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span> </div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00210" data-start="{" data-end="}">
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern12.html#abee77e01af24c67dfc897e85cc9fe9e0">  210</a></span>        <span class="keyword">typename</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Matern12&lt;T, V&gt;::RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern12.html#abee77e01af24c67dfc897e85cc9fe9e0">Matern12&lt;T, V&gt;::evaluate_kernel</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) {</div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distances = calculate_distance(x1, x2);</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>            <span class="keywordflow">return</span> evaluate_kernel(distances);</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>        }</div>
</div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span> </div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00216" data-start="{" data-end="}">
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern12.html#afe39812dc7ba20fbd9dccd36ef0b84cb">  216</a></span>        <span class="keyword">typename</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Matern12&lt;T, V&gt;::RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern12.html#afe39812dc7ba20fbd9dccd36ef0b84cb">Matern12&lt;T, V&gt;::calculate_distance</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) {</div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>            <span class="keywordflow">return</span> this-&gt;_quadratic_distance(x1, x2);</div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>        }</div>
</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span> </div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span> </div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>        <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>        <span class="comment">// Matern3/2</span></div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>        <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span> </div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00226" data-start="{" data-end="}">
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern32.html#ac682da6ddca9bf7716c4f8a24a737b42">  226</a></span>        <span class="keyword">typename</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Matern32&lt;T, V&gt;::RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern32.html#aaec97a47e2fbdafeb544a133a1096ff5">Matern32&lt;T, V&gt;::evaluate_kernel</a>(<a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distance) {</div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span> </div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span><span class="preprocessor">#ifdef USE_TAYLORMADE_RELAXATIONS</span></div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>            <span class="keywordflow">return</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern&lt;T, V&gt;::_data</a>-&gt;sf2 * <a class="code hl_function" href="namespacemelon_1_1kernel.html#af6326be288cac254a67493632f4ddf76">covar_matern_3</a>(distance);</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> euclidianDistance = sqrt(distance + 1e-16);</div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> sqrtK = sqrt(3.0) * euclidianDistance;</div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>            <span class="comment">// we multiply the covariance function out because we found that it has tighter relaxations</span></div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>            <span class="keywordflow">return</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern&lt;T, V&gt;::_data</a>-&gt;sf2 * (exp(-sqrtK) + sqrtK * exp(-sqrtK));</div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span> </div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>        }</div>
</div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span> </div>
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span> </div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00241" data-start="{" data-end="}">
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern32.html#aaec97a47e2fbdafeb544a133a1096ff5">  241</a></span>        <span class="keyword">typename</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Matern32&lt;T, V&gt;::RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern32.html#aaec97a47e2fbdafeb544a133a1096ff5">Matern32&lt;T, V&gt;::evaluate_kernel</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) {</div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distances = calculate_distance(x1, x2);</div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>            <span class="keywordflow">return</span> evaluate_kernel(distances);</div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>        }</div>
</div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span> </div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00247" data-start="{" data-end="}">
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern32.html#aa162953dea6b15059836429dbd05607d">  247</a></span>        <span class="keyword">typename</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Matern32&lt;T, V&gt;::RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern32.html#aa162953dea6b15059836429dbd05607d">Matern32&lt;T, V&gt;::calculate_distance</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) {</div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>            <span class="keywordflow">return</span> this-&gt;_quadratic_distance(x1, x2);</div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span>        }</div>
</div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span> </div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span> </div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span>        <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span>        <span class="comment">// Matern5/2</span></div>
<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span>        <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span> </div>
<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00257" data-start="{" data-end="}">
<div class="line"><a id="l00257" name="l00257"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern52.html#a3f75446eb7f7b7a8dd79fb0c62b0f6c6">  257</a></span>        <span class="keyword">typename</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Matern52&lt;T, V&gt;::RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern52.html#afa52e2e7fcf02852db995e5570303609">Matern52&lt;T, V&gt;::evaluate_kernel</a>(<a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distance) {</div>
<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span> </div>
<div class="line"><a id="l00259" name="l00259"></a><span class="lineno">  259</span><span class="preprocessor">#ifdef USE_TAYLORMADE_RELAXATIONS</span></div>
<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span>            <span class="comment">// use xexpax as envelope is implemented. return _data-&gt;sf2 * (1 + sqrtK) * exp(-sqrtK);</span></div>
<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span>            <span class="keywordflow">return</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern&lt;T, V&gt;::_data</a>-&gt;sf2 * <a class="code hl_function" href="namespacemelon_1_1kernel.html#a1805b33bc8adf981fa654aaf8ff1fae7">covar_matern_5</a>(distance);</div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> euclidianDistance = sqrt(distance + 1e-16);</div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> sqrtK = sqrt(5.0) * euclidianDistance;</div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> sqrtK2_3 = 5. / 3. * distance;</div>
<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span>            <span class="comment">// we multiply the covariance function out because we found that it has tighter relaxations</span></div>
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span>            <span class="comment">// return Matern&lt;T, V&gt;::_data-&gt;sf2 * (1 + sqrtK + sqrtK2_3) * exp(-sqrtK);</span></div>
<div class="line"><a id="l00268" name="l00268"></a><span class="lineno">  268</span>            <span class="keywordflow">return</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern&lt;T, V&gt;::_data</a>-&gt;sf2 * (exp(-sqrtK) + sqrtK * exp(-sqrtK) + sqrtK2_3 * exp(-sqrtK));</div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00270" name="l00270"></a><span class="lineno">  270</span> </div>
<div class="line"><a id="l00271" name="l00271"></a><span class="lineno">  271</span>        }</div>
</div>
<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span> </div>
<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00274" data-start="{" data-end="}">
<div class="line"><a id="l00274" name="l00274"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern52.html#afa52e2e7fcf02852db995e5570303609">  274</a></span>        <span class="keyword">typename</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Matern52&lt;T, V&gt;::RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern52.html#afa52e2e7fcf02852db995e5570303609">Matern52&lt;T, V&gt;::evaluate_kernel</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) {</div>
<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distances = calculate_distance(x1, x2);</div>
<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span>            <span class="keywordflow">return</span> evaluate_kernel(distances);</div>
<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span>        }</div>
</div>
<div class="line"><a id="l00278" name="l00278"></a><span class="lineno">  278</span> </div>
<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00280" data-start="{" data-end="}">
<div class="line"><a id="l00280" name="l00280"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern52.html#a0858a9caccf0a87cd283504d80cc5fea">  280</a></span>        <span class="keyword">typename</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">Matern52&lt;T, V&gt;::RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern52.html#a0858a9caccf0a87cd283504d80cc5fea">Matern52&lt;T, V&gt;::calculate_distance</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) {</div>
<div class="line"><a id="l00281" name="l00281"></a><span class="lineno">  281</span>            <span class="keywordflow">return</span> this-&gt;_quadratic_distance(x1, x2);</div>
<div class="line"><a id="l00282" name="l00282"></a><span class="lineno">  282</span>        }</div>
</div>
<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span> </div>
<div class="line"><a id="l00284" name="l00284"></a><span class="lineno">  284</span> </div>
<div class="line"><a id="l00285" name="l00285"></a><span class="lineno">  285</span>        <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00286" name="l00286"></a><span class="lineno">  286</span>        <span class="comment">// MaternInf (squared exponential)</span></div>
<div class="line"><a id="l00287" name="l00287"></a><span class="lineno">  287</span>        <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00288" name="l00288"></a><span class="lineno">  288</span> </div>
<div class="line"><a id="l00289" name="l00289"></a><span class="lineno">  289</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00290" data-start="{" data-end="}">
<div class="line"><a id="l00290" name="l00290"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern_inf.html#a54d5e99a3e595bf9197bc79ec9e1a27d">  290</a></span>        <span class="keyword">typename</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">MaternInf&lt;T, V&gt;::RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern_inf.html#a234fac115337961d3b38bf311003f39e">MaternInf&lt;T, V&gt;::evaluate_kernel</a>(<a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distance) {</div>
<div class="line"><a id="l00291" name="l00291"></a><span class="lineno">  291</span> </div>
<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span><span class="preprocessor">#ifdef USE_TAYLORMADE_RELAXATIONS</span></div>
<div class="line"><a id="l00293" name="l00293"></a><span class="lineno">  293</span>            <span class="keywordflow">return</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern&lt;T, V&gt;::_data</a>-&gt;sf2 * <a class="code hl_function" href="namespacemelon_1_1kernel.html#a2a227d1955df0c4b01af2c41b9470e95">covar_sqrexp</a>(distance);</div>
<div class="line"><a id="l00294" name="l00294"></a><span class="lineno">  294</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00295" name="l00295"></a><span class="lineno">  295</span>            <span class="keywordflow">return</span> <a class="code hl_class" href="classmelon_1_1kernel_1_1_matern.html">Matern&lt;T, V&gt;::_data</a>-&gt;sf2 * exp(-0.5 * distance);</div>
<div class="line"><a id="l00296" name="l00296"></a><span class="lineno">  296</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00297" name="l00297"></a><span class="lineno">  297</span> </div>
<div class="line"><a id="l00298" name="l00298"></a><span class="lineno">  298</span>        }</div>
</div>
<div class="line"><a id="l00299" name="l00299"></a><span class="lineno">  299</span> </div>
<div class="line"><a id="l00300" name="l00300"></a><span class="lineno">  300</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00301" data-start="{" data-end="}">
<div class="line"><a id="l00301" name="l00301"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern_inf.html#a234fac115337961d3b38bf311003f39e">  301</a></span>        <span class="keyword">typename</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">MaternInf&lt;T, V&gt;::RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern_inf.html#a234fac115337961d3b38bf311003f39e">MaternInf&lt;T, V&gt;::evaluate_kernel</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) {</div>
<div class="line"><a id="l00302" name="l00302"></a><span class="lineno">  302</span>            <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> distances = calculate_distance(x1, x2);</div>
<div class="line"><a id="l00303" name="l00303"></a><span class="lineno">  303</span>            <span class="keywordflow">return</span> evaluate_kernel(distances);</div>
<div class="line"><a id="l00304" name="l00304"></a><span class="lineno">  304</span>        }</div>
</div>
<div class="line"><a id="l00305" name="l00305"></a><span class="lineno">  305</span> </div>
<div class="line"><a id="l00306" name="l00306"></a><span class="lineno">  306</span> </div>
<div class="line"><a id="l00307" name="l00307"></a><span class="lineno">  307</span>        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> V&gt;</div>
<div class="foldopen" id="foldopen00308" data-start="{" data-end="}">
<div class="line"><a id="l00308" name="l00308"></a><span class="lineno"><a class="line" href="classmelon_1_1kernel_1_1_matern_inf.html#a4ac55cf3cc87491b112617c987bf69b9">  308</a></span>        <span class="keyword">typename</span> <a class="code hl_typedef" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">MaternInf&lt;T, V&gt;::RET</a> <a class="code hl_function" href="classmelon_1_1kernel_1_1_matern_inf.html#a4ac55cf3cc87491b112617c987bf69b9">MaternInf&lt;T, V&gt;::calculate_distance</a>(std::vector&lt;T&gt; x1, std::vector&lt;V&gt; x2) {</div>
<div class="line"><a id="l00309" name="l00309"></a><span class="lineno">  309</span>            <span class="keywordflow">return</span> this-&gt;_quadratic_distance(x1, x2);</div>
<div class="line"><a id="l00310" name="l00310"></a><span class="lineno">  310</span>        }</div>
</div>
<div class="line"><a id="l00311" name="l00311"></a><span class="lineno">  311</span>    }</div>
<div class="line"><a id="l00312" name="l00312"></a><span class="lineno">  312</span>}</div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_kernel_html_afc65772b466950a64138b8914d44a0b1"><div class="ttname"><a href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">melon::kernel::Kernel::RET</a></div><div class="ttdeci">decltype(std::declval&lt; T &gt;()+std::declval&lt; V &gt;()) RET</div><div class="ttdef"><b>Definition</b> kernel.h:33</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern12_html"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern12.html">melon::kernel::Matern12</a></div><div class="ttdoc">Class implementation of Matern12 kernel.</div><div class="ttdef"><b>Definition</b> matern.h:126</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern12_html_abee77e01af24c67dfc897e85cc9fe9e0"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern12.html#abee77e01af24c67dfc897e85cc9fe9e0">melon::kernel::Matern12::evaluate_kernel</a></div><div class="ttdeci">RET evaluate_kernel(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)</div><div class="ttdoc">Function for evalualting the kernel for the points x1 and x2.</div><div class="ttdef"><b>Definition</b> matern.h:210</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern12_html_afe39812dc7ba20fbd9dccd36ef0b84cb"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern12.html#afe39812dc7ba20fbd9dccd36ef0b84cb">melon::kernel::Matern12::calculate_distance</a></div><div class="ttdeci">RET calculate_distance(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)</div><div class="ttdoc">Function for calculating the distance used in the kernel (type of distance used can vary among kernel...</div><div class="ttdef"><b>Definition</b> matern.h:216</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern32_html"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern32.html">melon::kernel::Matern32</a></div><div class="ttdoc">Class implementation of Matern32 kernel.</div><div class="ttdef"><b>Definition</b> matern.h:141</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern32_html_aa162953dea6b15059836429dbd05607d"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern32.html#aa162953dea6b15059836429dbd05607d">melon::kernel::Matern32::calculate_distance</a></div><div class="ttdeci">RET calculate_distance(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)</div><div class="ttdoc">Function for calculating the distance used in the kernel (type of distance used can vary among kernel...</div><div class="ttdef"><b>Definition</b> matern.h:247</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern32_html_aaec97a47e2fbdafeb544a133a1096ff5"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern32.html#aaec97a47e2fbdafeb544a133a1096ff5">melon::kernel::Matern32::evaluate_kernel</a></div><div class="ttdeci">RET evaluate_kernel(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)</div><div class="ttdoc">Function for evalualting the kernel for the points x1 and x2.</div><div class="ttdef"><b>Definition</b> matern.h:241</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern52_html"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern52.html">melon::kernel::Matern52</a></div><div class="ttdoc">Class implementation of Matern52 kernel.</div><div class="ttdef"><b>Definition</b> matern.h:156</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern52_html_a0858a9caccf0a87cd283504d80cc5fea"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern52.html#a0858a9caccf0a87cd283504d80cc5fea">melon::kernel::Matern52::calculate_distance</a></div><div class="ttdeci">RET calculate_distance(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)</div><div class="ttdoc">Function for calculating the distance used in the kernel (type of distance used can vary among kernel...</div><div class="ttdef"><b>Definition</b> matern.h:280</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern52_html_afa52e2e7fcf02852db995e5570303609"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern52.html#afa52e2e7fcf02852db995e5570303609">melon::kernel::Matern52::evaluate_kernel</a></div><div class="ttdeci">RET evaluate_kernel(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)</div><div class="ttdoc">Function for evalualting the kernel for the points x1 and x2.</div><div class="ttdef"><b>Definition</b> matern.h:274</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern_html"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern.html">melon::kernel::Matern</a></div><div class="ttdoc">Abstract parent class for matern kernels.</div><div class="ttdef"><b>Definition</b> matern.h:74</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern_html_a23dc40f992932497afc16a00f20f2e77"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern.html#a23dc40f992932497afc16a00f20f2e77">melon::kernel::Matern::_quadratic_distance</a></div><div class="ttdeci">RET _quadratic_distance(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2) override</div><div class="ttdoc">Calculates the quadratic distance between two points x1 and x2.</div><div class="ttdef"><b>Definition</b> matern.h:91</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern_html_a85fac54714c648155ccb76ca58b140dc"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern.html#a85fac54714c648155ccb76ca58b140dc">melon::kernel::Matern::_euclidian_distance</a></div><div class="ttdeci">auto _euclidian_distance(RET quadraticDistance)</div><div class="ttdoc">Calculates the euclidian distance from the quadratic distance.</div><div class="ttdef"><b>Definition</b> matern.h:106</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern_html_a949e9259d57135cf1dbb1b8c8fa2bd2f"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern.html#a949e9259d57135cf1dbb1b8c8fa2bd2f">melon::kernel::Matern::Matern</a></div><div class="ttdeci">Matern()</div><div class="ttdef"><b>Definition</b> matern.h:186</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern_html_afd32a89a7eeff017e7c811c4c4a3a64e"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern.html#afd32a89a7eeff017e7c811c4c4a3a64e">melon::kernel::Matern::_data</a></div><div class="ttdeci">std::shared_ptr&lt; const KernelData &gt; _data</div><div class="ttdef"><b>Definition</b> matern.h:82</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern_inf_html"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern_inf.html">melon::kernel::MaternInf</a></div><div class="ttdoc">Class implementation of MaternInf kernel.</div><div class="ttdef"><b>Definition</b> matern.h:171</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern_inf_html_a234fac115337961d3b38bf311003f39e"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern_inf.html#a234fac115337961d3b38bf311003f39e">melon::kernel::MaternInf::evaluate_kernel</a></div><div class="ttdeci">RET evaluate_kernel(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)</div><div class="ttdoc">Function for evalualting the kernel for the points x1 and x2.</div><div class="ttdef"><b>Definition</b> matern.h:301</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_matern_inf_html_a4ac55cf3cc87491b112617c987bf69b9"><div class="ttname"><a href="classmelon_1_1kernel_1_1_matern_inf.html#a4ac55cf3cc87491b112617c987bf69b9">melon::kernel::MaternInf::calculate_distance</a></div><div class="ttdeci">RET calculate_distance(std::vector&lt; T &gt; x1, std::vector&lt; V &gt; x2)</div><div class="ttdoc">Function for calculating the distance used in the kernel (type of distance used can vary among kernel...</div><div class="ttdef"><b>Definition</b> matern.h:308</div></div>
<div class="ttc" id="aclassmelon_1_1kernel_1_1_stationary_kernel_html"><div class="ttname"><a href="classmelon_1_1kernel_1_1_stationary_kernel.html">melon::kernel::StationaryKernel</a></div><div class="ttdef"><b>Definition</b> kernel.h:58</div></div>
<div class="ttc" id="akernel_8h_html"><div class="ttname"><a href="kernel_8h.html">kernel.h</a></div></div>
<div class="ttc" id="anamespacemelon_1_1kernel_html_a1805b33bc8adf981fa654aaf8ff1fae7"><div class="ttname"><a href="namespacemelon_1_1kernel.html#a1805b33bc8adf981fa654aaf8ff1fae7">melon::kernel::covar_matern_5</a></div><div class="ttdeci">T covar_matern_5(const T &amp;x)</div><div class="ttdef"><b>Definition</b> matern.h:49</div></div>
<div class="ttc" id="anamespacemelon_1_1kernel_html_a2a227d1955df0c4b01af2c41b9470e95"><div class="ttname"><a href="namespacemelon_1_1kernel.html#a2a227d1955df0c4b01af2c41b9470e95">melon::kernel::covar_sqrexp</a></div><div class="ttdeci">T covar_sqrexp(const T &amp;x)</div><div class="ttdef"><b>Definition</b> matern.h:55</div></div>
<div class="ttc" id="anamespacemelon_1_1kernel_html_af325146267524e3bec94d0535ffcebcb"><div class="ttname"><a href="namespacemelon_1_1kernel.html#af325146267524e3bec94d0535ffcebcb">melon::kernel::covar_matern_1</a></div><div class="ttdeci">T covar_matern_1(const T &amp;x)</div><div class="ttdef"><b>Definition</b> matern.h:37</div></div>
<div class="ttc" id="anamespacemelon_1_1kernel_html_af6326be288cac254a67493632f4ddf76"><div class="ttname"><a href="namespacemelon_1_1kernel.html#af6326be288cac254a67493632f4ddf76">melon::kernel::covar_matern_3</a></div><div class="ttdeci">T covar_matern_3(const T &amp;x)</div><div class="ttdef"><b>Definition</b> matern.h:43</div></div>
<div class="ttc" id="anamespacemelon_html"><div class="ttname"><a href="namespacemelon.html">melon</a></div><div class="ttdef"><b>Definition</b> kernel.h:21</div></div>
<div class="ttc" id="astructmelon_1_1kernel_1_1_kernel_data_html"><div class="ttname"><a href="structmelon_1_1kernel_1_1_kernel_data.html">melon::kernel::KernelData</a></div><div class="ttdoc">struct containing kernel parameters</div><div class="ttdef"><b>Definition</b> matern.h:64</div></div>
<div class="ttc" id="astructmelon_1_1kernel_1_1_kernel_data_html_a17fc12e78f39a1e93d89f241083ebab1"><div class="ttname"><a href="structmelon_1_1kernel_1_1_kernel_data.html#a17fc12e78f39a1e93d89f241083ebab1">melon::kernel::KernelData::sf2</a></div><div class="ttdeci">double sf2</div><div class="ttdef"><b>Definition</b> matern.h:65</div></div>
<div class="ttc" id="astructmelon_1_1kernel_1_1_kernel_data_html_ad3f01d89c0bfdd53dda0b31f84319dcf"><div class="ttname"><a href="structmelon_1_1kernel_1_1_kernel_data.html#ad3f01d89c0bfdd53dda0b31f84319dcf">melon::kernel::KernelData::ell</a></div><div class="ttdeci">std::vector&lt; double &gt; ell</div><div class="ttdef"><b>Definition</b> matern.h:66</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_bdd9a5d540de89e9fe90efdfc6973a4f.html">common</a></li><li class="navelem"><a class="el" href="dir_a065f42410ce59d310ee6ca453a28844.html">inc</a></li><li class="navelem"><a class="el" href="matern_8h.html">matern.h</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
